import * as v from 'valibot';
import { idRegex } from '../u-query.js';
export var ClaimsQuery;
(function (ClaimsQuery) {
    ClaimsQuery.vValue = v.union([v.string(), v.number(), v.boolean()]);
    ClaimsQuery.vPath = v.union([
        v.string(),
        v.pipe(v.number(), v.integer(), v.minValue(0)),
        v.literal('*'),
    ]);
    ClaimsQuery.vW3cSdJwtVc = v.object({
        id: v.optional(v.pipe(v.string(), v.regex(idRegex))),
        path: v.optional(v.array(ClaimsQuery.vPath)),
        values: v.optional(v.array(ClaimsQuery.vValue)),
    });
    ClaimsQuery.vMdoc = v.object({
        id: v.optional(v.pipe(v.string(), v.regex(idRegex))),
        namespace: v.string(),
        claim_name: v.string(),
        values: v.optional(v.array(ClaimsQuery.vValue)),
    });
    ClaimsQuery.vModel = v.union([ClaimsQuery.vMdoc, ClaimsQuery.vW3cSdJwtVc]);
})(ClaimsQuery || (ClaimsQuery = {}));
//# sourceMappingURL=v-claims-query.js.map